Index: documentation/trunk/tutorials/xml-source/tutorial_en.xml
===================================================================
--- documentation/trunk/tutorials/xml-source/tutorial_en.xml	(revision 24611)
+++ documentation/trunk/tutorials/xml-source/tutorial_en.xml	(revision 24617)
@@ -1544,5 +1544,5 @@
 </NumberedItem>
 <NumberedItem>
-<Text id="0414">In a web browser, visit <Link>http://englishhistory.net</Link>, follow the link to <i>Tudor England</i>, and click &lt;<b>Enter</b>&gt;. You should be at the URL</Text>
+<Text id="0414">In a web browser, visit <Link>http://englishhistory.net</Link>, follow the link to <i>Tudor England</i>. You should be at the URL</Text>
 <Link>http://englishhistory.net/tudor.html</Link> 
 <Text id="0415">This is where we started the downloading process to obtain the files you have been using for the <b>tudor</b> collection. You could do the same thing by copying this URL from the web browser, pasting it into the <AutoText key="glidict::GUI.Download"/> panel, and clicking the <AutoText key="glidict::Mirroring.Download" type="button"/> button. However, several megabytes will be downloaded, which might strain your network resources&mdash;or your patience! For a faster exercise we focus on a smaller section of the site. </Text>
@@ -1787,5 +1787,5 @@
 </NumberedItem>
 <NumberedItem>
-<Text id="is-10">In the <AutoText key="glidict::CDM.GUI.Classifiers"/> section, remove the existing (useless) classifiers for <AutoText text="dc.Title;ex.Title"/> and <AutoText text="ex.Source"/>, and add a new <AutoText text="List"/> for <AutoText text="ex.Photographer"/>.</Text>
+<Text id="is-10">In the <AutoText key="glidict::CDM.GUI.Classifiers"/> section of the <AutoText key="glidict::GUI.Design"/> panel, remove the existing (useless) classifiers for <AutoText text="dc.Title;ex.Title"/> and <AutoText text="ex.Source"/>, and add a new <AutoText text="List"/> for <AutoText text="ex.Photographer"/>.</Text>
 </NumberedItem>
 <NumberedItem>
@@ -1933,5 +1933,5 @@
 <Format>
 body {<br/>
-  background: #ffffff;<br/>
+  background-color: #ffffff;<br/>
 }
 </Format>
@@ -1988,5 +1988,5 @@
 <Text id="mf-43">Make your own Greenstone home page</Text>
 </Heading>
-<Text id="mf-44">You can make radical changes to a page by changing the macro file completely. For example, here we use a alternative to the home page which we have prepared for you in advance and included in your Greenstone installation.</Text>
+<Text id="mf-44">You can make radical changes to a page by changing the macro file completely. For example, here we use an alternative to the home page which we have prepared for you in advance and included in your Greenstone installation.</Text>
 <NumberedItem>
 <Text id="mf-45">Open the file <Path>Greenstone &rarr; etc &rarr; main.cfg</Path> in a text editor. Locate the <AutoText text="macrofiles" type="italics"/> list:</Text>
@@ -2014,5 +2014,5 @@
 </Heading>
 <NumberedItem>
-<Text id="mf-64">In the step 10 of this exercise we replaced the default background (<AutoText text="chalk.gif"/>) and header (<AutoText text="gsdlhead.gif"/>) images with new ones. To do this we needed to change the image names in the macro files. How did we know which images we were replacing and which macro files to edit? This exercise shows you how to find out.</Text>
+<Text id="mf-64">In step 10 of this exercise we replaced the default background (<AutoText text="chalk.gif"/>) and header (<AutoText text="gsdlhead.gif"/>) images with new ones. To do this we needed to change the image names in the macro files. How did we know which images we were replacing and which macro files to edit? This exercise shows you how to find out.</Text>
 </NumberedItem>
 <NumberedItem>
@@ -2027,5 +2027,6 @@
 <Text id="mf-69">To search the macro files for <i><AutoText text="gsdlhead.gif" /></i> type</Text>
 <Command>findstr /s /m /C:"gsdlhead.gif" "C:\Program Files\Greenstone\macros\*.dm"</Command>
-<Text id="mf-70"><AutoText text="*.dm"/> means all files ending in <AutoText text=".dm"/> (while <AutoText text="/s"/> tells it to search within subfolders and <AutoText text="/m"/> lists the files that matched). A list of all macro files will be displayed, along with any matches. You will see that <Path>home.dm</Path> and <Path>exported_home.dm</Path> both contain <AutoText text="gsdlhead.gif"/>. <Path>home.dm</Path> is the one you want to edit&mdash;<Path>exported_home.dm</Path> is used for the home page when you export a collection to CD-ROM.</Text>
+<Text id="mf-70"><AutoText text="*.dm"/> means all files ending in <AutoText text=".dm"/> (while <AutoText text="/s"/> tells it to search within subfolders and <AutoText text="/m"/> lists the files that matched). A list of all applicable macro files will be displayed, along with any matches. You will see that <Path>home.dm</Path> and <Path>exported_home.dm</Path> both contain <AutoText text="gsdlhead.gif"/>. <Path>home.dm</Path> is the one you want to edit&mdash;<Path>exported_home.dm</Path> is used for the home page when you export a collection to CD-ROM. On Linux systems, the equivalent command to run in a terminal would be:</Text>
+<Command>fgrep -rl "gsdlhead.gif" /full/path/to/your/greenstone/macros/.</Command>
 <Text id="mf-71">Do the same thing for <i><AutoText text="chalk.gif" /></i>:</Text>
 <Command>findstr /s /m /C:"chalk.gif" "C:\Program Files\Greenstone\macros\*.dm"</Command>
@@ -2053,5 +2054,5 @@
 </NumberedItem>
 <NumberedItem>
-<Text id="0544">On Windows, if the Greenstone Digital Library Local Library Server is already running, re-start it by clicking the world icon on the task bar and then pressing <i>Restart Library</i>. On Linux and Mac, just do a forced reload/refresh of the web browser (eg. by pressing Shift and the refresh button in Firefox to do a forced reload). If the Local Library Server hasn't been started yet, start it up by selecting <i>Greenstone Digital Library</i> from the <i>Start</i> menu on Windows, or run <Path>./gs-server.sh</Path> on Linux and Mac.</Text>
+<Text id="0544">On Windows, if the Greenstone Digital Library Local Library Server is already running, re-start it by clicking the world icon on the task bar and then pressing <i>Restart Library</i>. On Linux and Mac, just do a forced reload/refresh of the web browser (eg. by pressing Shift and the refresh button in Firefox to do a forced reload). If the Local Library Server hasn't been started yet, start it up first by selecting <i>Greenstone Digital Library</i> from the <i>Start</i> menu on Windows, or run <Path>./gs-server.sh</Path> on Linux and Mac.</Text>
 </NumberedItem>
 <NumberedItem>
@@ -2133,5 +2134,5 @@
 </Bullet>
 <Bullet>
-<Text id="0574">Add a <AutoText text="List"/> classifier and click the <AutoText text="bookshelf_type"/> and select <AutoText text="always"/> in the drop-down list. Select <AutoText key="metadata::dc.Format"/> as the <AutoText text="metadata"/> field and specify "browse" as the <AutoText text="buttonname"/>. Click the <AutoText text="partition_type_within_level"/> check box and choose <AutoText text="none"/> from the drop-down list. Click the <AutoText text="sort_leaf_nodes_using"/> checkbox, and select <AutoText key="metadata::ex.Title"/> in the drop-down list: this will make the classifier display documents in alphabetical order of title.</Text>
+<Text id="0574">Add a <AutoText text="List"/> classifier and select <AutoText key="metadata::dc.Format"/> as the <AutoText text="metadata"/> field. Click the <AutoText text="bookshelf_type"/> and select <AutoText text="always"/> in the drop-down list. Click the <AutoText text="partition_type_within_level"/> check box and choose <AutoText text="none"/> from the drop-down list. Click the <AutoText text="sort_leaf_nodes_using"/> checkbox, and select <AutoText key="metadata::ex.Title"/> in the drop-down list: this will make the classifier display documents in alphabetical order of title. Specify <AutoText text="browse"/> as the <AutoText text="buttonname"/>.</Text>
 </Bullet>
 </BulletList>
@@ -2415,5 +2416,5 @@
 </NumberedItem>
 <NumberedItem>
-<Text id="0673">Now change to the <AutoText key="glidict::GUI.Create"/> panel and <b>build</b> and <b>preview</b> the collection.</Text>
+<Text id="0673">Now change to the <AutoText key="glidict::GUI.Create"/> panel and <b>build</b> and <b>preview</b> the collection. Try out the <AutoText text="collage"/> browsing classifier. You can click on any image during the collage display and the image will be opened up.</Text>
 </NumberedItem>
 </Content>
@@ -2785,5 +2786,5 @@
 </Comment>
 <NumberedItem>
-<Text id="oai-plugin-option">You need to specify which document the OAI metadata values should be attached to. In the <AutoText key="glidict::GUI.Design"/> panel, select the <AutoText key="glidict::CDM.GUI.Plugins"/> section, then select the <AutoText text="OAIPlugin"/> and click <AutoText key="glidict::CDM.PlugInManager.Configure" type="button"/>. Locate the <AutoText text="document_field"/> option in the popup window and select <AutoText text="dc.Resource Identifier"/> from the drop-down list. Click <AutoText key="glidict::General.OK" type="button"/>. Move the <AutoText text="OAIPlugin"/> above the <AutoText text="EmbeddedMetadataPlugin"/>.</Text>
+<Text id="oai-plugin-option">Move the <AutoText text="OAIPlugin"/> above the <AutoText text="EmbeddedMetadataPlugin"/>. Next, you will need to specify which document the OAI metadata values should be attached to. In the <AutoText key="glidict::GUI.Design"/> panel, select the <AutoText key="glidict::CDM.GUI.Plugins"/> section, then select the <AutoText text="OAIPlugin"/> and click <AutoText key="glidict::CDM.PlugInManager.Configure" type="button"/>. Locate the <AutoText text="document_field"/> option in the popup window and select <AutoText text="dc.Resource Identifier"/> from the drop-down list. Click <AutoText key="glidict::General.OK" type="button"/>.</Text>
 </NumberedItem>
 <NumberedItem>
@@ -2801,5 +2802,5 @@
 </NumberedItem>
 <NumberedItem>
-<Text id="0714">Add an <AutoText text="AZCompactList" /> classifier based on <AutoText key="metadata::ex.dc.Subject"/> metadata. Configure it with "subjects" as the <AutoText text="buttonname"/>.</Text>
+<Text id="0714">Add an <AutoText text="AZCompactList" /> classifier based on <AutoText key="metadata::ex.dc.Subject"/> metadata. Configure it with <AutoText text="subjects"/> as the <AutoText text="buttonname"/>.</Text>
 </NumberedItem>
 <NumberedItem>
@@ -2808,5 +2809,5 @@
 </NumberedItem>
 <NumberedItem>
-<Text id="0716">In the <AutoText key="glidict::CDM.GUI.Indexes"/> section of the <AutoText key="glidict::GUI.Design"/> panel, delete all indexes and add a new one based on <AutoText key="metadata::ex.dc.Description"/> metadata. Set the <AutoText text="Display text"/> for the <AutoText key="metadata::ex.dc.Description"/> index by going to the <AutoText key="glidict::CDM.GUI.SearchMetadata"/> section in the <AutoText key="glidict::GUI.Format"/> panel and changing its label to "_labelDescription_".</Text> 
+<Text id="0716">In the <AutoText key="glidict::CDM.GUI.Indexes"/> section of the <AutoText key="glidict::GUI.Design"/> panel, delete all indexes and add a new one based on <AutoText key="metadata::ex.dc.Description"/> metadata. Set the <AutoText text="Display text"/> for the <AutoText key="metadata::ex.dc.Description"/> index by going to the <AutoText key="glidict::CDM.GUI.SearchMetadata"/> section in the <AutoText key="glidict::GUI.Format"/> panel and changing its label to "_labelDescription_". Using a macro for an index name means that it will display in the correct language (assuming that the macro has been translated). You can check <Path>Greenstone &rarr; macros &rarr; english.dm</Path> to see which macros are available.</Text> 
 </NumberedItem>
 <NumberedItem>
@@ -3017,5 +3018,5 @@
 </NumberedItem>
 <NumberedItem>
-<Text id="0779">Go back to the <AutoText key="glidict::GUI.Design"/> panel, select <AutoText key="glidict::CDM.GUI.Classifiers"/>. Select the <AutoText key="metadata::ex.Source"/> <AutoText text="List" /> classifier and click <AutoText key="glidict::CDM.ClassifierManager.Configure" type="button"/>. Change the <AutoText text="metadata"/> option to <AutoText key="metadata::ex.dc.Contributor"/>. Activate the <AutoText text="bookshelf_type"/> option and set its value to <AutoText text="always"/>. If not already active, activate the <AutoText text="partition_type_within_level"/> option. Then set it to <AutoText text="none"/>. Finally, activate <AutoText text="buttonname"/> and set this to "contributors". Click <AutoText key="glidict::General.OK" type="button"/> to close the dialog.</Text>
+<Text id="0779">Go back to the <AutoText key="glidict::GUI.Design"/> panel, select <AutoText key="glidict::CDM.GUI.Classifiers"/>. Select the <AutoText key="metadata::ex.Source"/> <AutoText text="List" /> classifier and click <AutoText key="glidict::CDM.ClassifierManager.Configure" type="button"/>. Change the <AutoText text="metadata"/> option to <AutoText key="metadata::ex.dc.Contributor"/>. Activate the <AutoText text="bookshelf_type"/> option and set its value to <AutoText text="always"/>. If not already active, activate the <AutoText text="partition_type_within_level"/> option. Then set it to <AutoText text="none"/>. Finally, activate <AutoText text="buttonname"/> and set this to <AutoText text="contributors"/>. Click <AutoText key="glidict::General.OK" type="button"/> to close the dialog.</Text>
 </NumberedItem>
 <NumberedItem>
@@ -3118,5 +3119,5 @@
 </NumberedItem>
 <NumberedItem>
-<Text id="gems-9">The new metadata set will be displayed. The left hand side list the elements (and sub-elements, if any) for the set, and the right hand side displays the set or element attributes. Since the new set was based on the Development Library Subset metadata set, it already contains all the elements from that set.</Text>
+<Text id="gems-9">The new metadata set will be displayed. The left hand side lists the elements (and sub-elements, if any) for the set, and the right hand side displays the set or element attributes. Since the new set was based on the Development Library Subset metadata set, it already contains all the elements from that set.</Text>
 </NumberedItem>
 <Heading>
@@ -3179,5 +3180,5 @@
 </NumberedItem>
 <NumberedItem>
-<Text id="lucene-3">Please note that stopwords are used by default with Lucene indexer, so searching for words like <i>the</i> will match 0 documents. There is also a message on the search page saying that such words are too common and were ignored.</Text>
+<Text id="lucene-3">Please note that stopwords are used by default with Lucene indexer, so searching for words like <i>the</i> will match 0 documents. This is explained in a message on the search page, which states that such words are too common and were ignored.</Text>
 </NumberedItem>
 <Heading>
@@ -3283,5 +3284,5 @@
 </NumberedItem>
 <NumberedItem>
-<Text id="depositor-user3">Let's modify the groups for the demo user. This user was added for the authentication demonstration collection to allow restricted access to some of the documents. If this user doesn't exist for you, create a new user by clicking on the <AutoText key="auxdm::_status:textaddusers_"/> link under the <AutoText key="auxdm::_status:textusermanage_"/> section on the left. Give it the name "demo" and password "demo".</Text>
+<Text id="depositor-user3">Let's modify the groups for the demo user. This user was added for the authentication demonstration collection to allow restricted access to some of the documents. If this user doesn't exist for you, create a new user by clicking on the <AutoText key="auxdm::_status:textaddusers_"/> link under the <AutoText key="auxdm::_status:textusermanage_"/> section on the left. Give it the name "demo" and password "demo". Click <AutoText text="submit"/>.</Text>
 </NumberedItem>
 <NumberedItem>
@@ -3290,5 +3291,5 @@
 <NumberedItem>
 <Text id="depositor-user5">At the end of each user entry there are two links: <AutoText key="auxdm::_userslistusers:textedituser_"/> and <AutoText key="auxdm::_userslistusers:textdeleteuser_"/>. Click <AutoText key="auxdm::_userslistusers:textedituser_"/> on the <AutoText text="demo"/> user account, and you will be shown more detailed information about the demo user. Add <AutoText text="demoluce-collection-editor"/> at the end of the <AutoText key="auxdm::_userslistusers:textgroups_"/> line, using a comma to separate group entries, so that the <AutoText key="auxdm::_userslistusers:textgroups_"/> field now contains: 
-<Format>demo, demoluce-collection-editor.</Format> (Note, if your collection shortname is not demoluce, then replace demoluce with the appropriate name in ***-collection-editor.)</Text>
+<Format>demo,demoluce-collection-editor.</Format> (Note, if your collection shortname is not demoluce, then replace demoluce with the appropriate name in ***-collection-editor.)</Text>
 </NumberedItem>
 <NumberedItem>
@@ -3334,5 +3335,5 @@
 </NumberedItem>
 <NumberedItem>
-<Text id="depositor-20">Go to the Greenstone's home page and click <AutoText key="coredm::_depositor:textdepositor_"/> button. Select <b>Demo Lucene</b> from the list and log in.</Text>
+<Text id="depositor-20">Go to the Greenstone's home page and click <AutoText key="coredm::_depositor:textdepositor_"/> button. Select <b>Demo Lucene</b> from the list and log in if asked to do so again.</Text>
 </NumberedItem>
 <NumberedItem>