Index: /main/trunk/model-cols-dev/peijones/etc/collectionConfig.bak
===================================================================
--- /main/trunk/model-cols-dev/peijones/etc/collectionConfig.bak	(revision 24629)
+++ /main/trunk/model-cols-dev/peijones/etc/collectionConfig.bak	(revision 24630)
@@ -65,8 +65,10 @@
             <option name="-metadata" value="dc.Title;Title"/>
             <option name="-partition_type_within_level" value="approximate_size"/>
+            <option name="-bookshelf_type" value="never"/>
         </classifier>
         <classifier name="AZCompactList">
             <option name="-metadata" value="Source"/>
             <option name="-removesuffix" value="(?i)\\..*"/>
+            <option name="-buttonname" value="Source"/>
         </classifier>
         <format><gsf:template match="documentNode"><td valign="top"><gsf:link type="document"><gsf:icon type="document"/></gsf:link></td><td valign="top"><gsf:link type="source"><gsf:choose-metadata><gsf:metadata name="thumbicon"/><gsf:metadata name="srcicon"/></gsf:choose-metadata></gsf:link></td><td valign="top"><gsf:choose-metadata><gsf:metadata name="dc.Title"/><gsf:metadata name="exp.Title"/><gsf:metadata name="Title"/><gsf:default>Untitled</gsf:default></gsf:choose-metadata><gsf:switch><gsf:metadata name="Source"/><gsf:when test="exists"><br/><i>(<gsf:metadata name="Source"/>)</i></gsf:when></gsf:switch></td></gsf:template><gsf:template match="classifierNode"><td valign="top"><gsf:link type="classifier"><gsf:icon type="classifier"/></gsf:link></td><td valign="top"><gsf:metadata name="srclink"/><gsf:choose-metadata><gsf:metadata name="thumbicon"/><gsf:metadata name="srcicon"/></gsf:choose-metadata><gsf:metadata name="/srclink"/></td><td valign="top"><gsf:choose-metadata><gsf:metadata name="dc.Title"/><gsf:metadata name="exp.Title"/><gsf:metadata name="Title"/><gsf:default>Untitled</gsf:default></gsf:choose-metadata><gsf:switch><gsf:metadata name="Source"/><gsf:when test="exists"><br/><i>(<gsf:metadata name="Source"/>)</i></gsf:when></gsf:switch></td></gsf:template><gsf:template match="classifierNode" mode="horizontal"><gsf:link type="horizontal"><gsf:metadata name="Title"/></gsf:link></gsf:template></format>
Index: /main/trunk/model-cols-dev/peijones/etc/collectionConfig.xml
===================================================================
--- /main/trunk/model-cols-dev/peijones/etc/collectionConfig.xml	(revision 24629)
+++ /main/trunk/model-cols-dev/peijones/etc/collectionConfig.xml	(revision 24630)
@@ -65,14 +65,78 @@
             <option name="-metadata" value="dc.Title;Title"/>
             <option name="-partition_type_within_level" value="approximate_size"/>
+            <option name="-bookshelf_type" value="never"/>
         </classifier>
         <classifier name="AZCompactList">
             <option name="-metadata" value="Source"/>
             <option name="-removesuffix" value="(?i)\\..*"/>
+            <option name="-buttonname" value="Source"/>
         </classifier>
         <format><gsf:template match="documentNode"><td valign="top"><gsf:link type="document"><gsf:icon type="document"/></gsf:link></td><td valign="top"><gsf:link type="source"><gsf:choose-metadata><gsf:metadata name="thumbicon"/><gsf:metadata name="srcicon"/></gsf:choose-metadata></gsf:link></td><td valign="top"><gsf:choose-metadata><gsf:metadata name="dc.Title"/><gsf:metadata name="exp.Title"/><gsf:metadata name="Title"/><gsf:default>Untitled</gsf:default></gsf:choose-metadata><gsf:switch><gsf:metadata name="Source"/><gsf:when test="exists"><br/><i>(<gsf:metadata name="Source"/>)</i></gsf:when></gsf:switch></td></gsf:template><gsf:template match="classifierNode"><td valign="top"><gsf:link type="classifier"><gsf:icon type="classifier"/></gsf:link></td><td valign="top"><gsf:metadata name="srclink"/><gsf:choose-metadata><gsf:metadata name="thumbicon"/><gsf:metadata name="srcicon"/></gsf:choose-metadata><gsf:metadata name="/srclink"/></td><td valign="top"><gsf:choose-metadata><gsf:metadata name="dc.Title"/><gsf:metadata name="exp.Title"/><gsf:metadata name="Title"/><gsf:default>Untitled</gsf:default></gsf:choose-metadata><gsf:switch><gsf:metadata name="Source"/><gsf:when test="exists"><br/><i>(<gsf:metadata name="Source"/>)</i></gsf:when></gsf:switch></td></gsf:template><gsf:template match="classifierNode" mode="horizontal"><gsf:link type="horizontal"><gsf:metadata name="Title"/></gsf:link></gsf:template></format>
     </browse>
     <display>
-        <format><gsf:option name="TOC" value="false"/><xsl:template match="documentNode" mode="document"><h3><gsf:metadata name="ex.Title"/></h3><xsl:variable name="imageWidth"><gsf:metadata name="ImageWidth"/></xsl:variable><xsl:variable name="imageHeight"><gsf:metadata name="ImageHeight"/></xsl:variable><xsl:variable name="screenImageWidth"><gsf:metadata name="ScreenWidth"/></xsl:variable><xsl:variable name="screenImageHeight"><gsf:metadata name="ScreenHeight"/></xsl:variable><script type="text/javascript"><xsl:text>largeImageHeight =</xsl:text><xsl:value-of select="$imageHeight"/><xsl:text>;</xsl:text><xsl:text>largeImageWidth =</xsl:text><xsl:value-of select="$imageWidth"/><xsl:text>;</xsl:text></script><div id="noZoom" style="display:block;"><gsf:metadata name="screenicon"/></div><div id="wrap" style="display:none"><div id="small" style="width: {$screenImageWidth}; height: {$screenImageHeight};"><gsf:metadata name="screenicon"/></div><div id="mover"><div id="overlay"><xsl:text/></div><div id="large"><img style="width: {$imageWidth}; height: {$imageHeight};"><xsl:attribute name="src"><xsl:value-of disable-output-escaping="yes" select="/page/pageResponse/collection/metadataList/metadata[@name='httpPath']"/>/index/assoc/<gsf:metadata name="assocfilepath"/>/<gsf:metadata name="srclinkFile"/></xsl:attribute></img></div></div></div></xsl:template> </format>
-    </display>
+        <format><gsf:option name="TOC" value="false"/>
+		<xsl:template name="additionalHeaderContent">
+			<script type="text/javascript" src="interfaces/{$interface_name}/js/jquery-1.4.2.js"><xsl:text> </xsl:text></script>
+			<script type="text/javascript" src="sites/localsite/collect/peijones/js/documentmaker/zoomer.jquery.js"><xsl:text> </xsl:text></script>
+			<link rel="stylesheet" type="text/css" href="sites/localsite/collect/peijones/style/style.css"/>
+			<script type="text/javascript">
+				<xsl:text disable-output-escaping="yes">
+					function readyImagesForZoom()
+					{
+						document.getElementById("noZoom").style.display = "none";
+						document.getElementById("wrap").style.display = "";
+						var smallImageDiv = document.getElementById("small");
+						var smallImage = smallImageDiv.getElementsByTagName("img")[0];
+						smallImageDiv.style.width = smallImage.clientWidth + "px";
+						smallImageDiv.style.height = smallImage.clientHeight + "px";
+						var multiplier = largeImageHeight / smallImage.clientHeight;
+						$("#wrap").anythingZoomer({
+							expansionSize:50,
+							speedMultiplier:multiplier
+						});
+					}
+					
+					function addZoom()
+					{
+						var wrapper = document.getElementById("wrap");
+						var noZoom = document.getElementById("noZoom");
+						
+						noZoom.style.display = "none";
+						wrapper.style.display = "block";
+						
+						var option = document.getElementById("zoomOption");
+						option.setAttribute("onclick", "removeZoom();");
+					}
+					
+					function removeZoom()
+					{
+						var wrapper = document.getElementById("wrap");
+						var noZoom = document.getElementById("noZoom");
+						
+						wrapper.style.display = "none";
+						noZoom.style.display = "block";
+						
+						var option = document.getElementById("zoomOption");
+						option.setAttribute("onclick", "addZoom();");
+					}
+				</xsl:text>
+			</script>
+		</xsl:template>
+		<xsl:template match="documentNode" mode="document">
+		<gsf:variable-struct name="photoNotes"><gsf:metadata name="gsimg.photoNote" multiple="true" separator=", "/></gsf:variable-struct>
+		<h3>
+		<gsf:choose-metadata>
+		  <gsf:metadata name="dc.Title"/>
+		  <gsf:metadata name="ex.Title"/>
+		</gsf:choose-metadata>
+		  </h3>
+		<xsl:variable name="imageWidth"><gsf:metadata name="ImageWidth"/>
+		</xsl:variable><xsl:variable name="imageHeight"><gsf:metadata name="ImageHeight"/>
+		</xsl:variable><xsl:variable name="screenImageWidth">
+		<gsf:metadata name="ScreenWidth"/>
+		</xsl:variable><xsl:variable name="screenImageHeight"><gsf:metadata name="ScreenHeight"/></xsl:variable><script type="text/javascript"><xsl:text>largeImageHeight =</xsl:text><xsl:value-of select="$imageHeight"/><xsl:text>;</xsl:text><xsl:text>largeImageWidth =</xsl:text><xsl:value-of select="$imageWidth"/><xsl:text>;</xsl:text></script><div id="noZoom" style="display:block;"><gsf:metadata name="screenicon"/></div><div id="wrap" style="display:none"><div id="small" style="width: {$screenImageWidth}; height: {$screenImageHeight};"><gsf:metadata name="screenicon"/></div><div id="mover"><div id="overlay"><xsl:text/></div><div id="large"><img style="width: {$imageWidth}; height: {$imageHeight};"><xsl:attribute name="src"><xsl:value-of disable-output-escaping="yes" select="/page/pageResponse/collection/metadataList/metadata[@name='httpPath']"/>/index/assoc/<gsf:metadata name="assocfilepath"/>/<gsf:metadata name="srclinkFile"/></xsl:attribute></img></div></div></div></xsl:template> 
+		</format>   
+	
+	</display>
     <replaceListRef id="gs2-standard"/>
     <replaceListRef id="gs2-image"/>
Index: /main/trunk/model-cols-dev/peijones/transform/pages/about.xsl
===================================================================
--- /main/trunk/model-cols-dev/peijones/transform/pages/about.xsl	(revision 24629)
+++ /main/trunk/model-cols-dev/peijones/transform/pages/about.xsl	(revision 24630)
@@ -23,8 +23,5 @@
 <xsl:text disable-output-escaping="yes">
 
-
-
   var collageDelayMsec = 2000;
-
   var numCollageImages;
 
@@ -71,8 +68,6 @@
     setTimeout('collageNextImage('+nextcollageFrameNum+')',collageDelayMsec);
 
-
  }
 
- 
  
 function initCollage()
@@ -134,5 +129,4 @@
       posStyle += "left: " + placement[i].x + "px; "; 
 
-
       visStyle = "visibility: inherit; ";
       zindexStyle = " z-index: " + numCollageImages + "; ";
@@ -148,5 +142,4 @@
 
 }
-
 
 </xsl:text>
@@ -168,5 +161,4 @@
 
 	var Book_Image_Sources = new Array();
-
 
 function getImages()
Index: /main/trunk/model-cols-dev/peijones/transform/pages/document.xsl
===================================================================
--- /main/trunk/model-cols-dev/peijones/transform/pages/document.xsl	(revision 24629)
+++ /main/trunk/model-cols-dev/peijones/transform/pages/document.xsl	(revision 24630)
@@ -125,5 +125,5 @@
                     newNote.Select();
                 }
-				window.onload = getNotes;
+				window.onload = function(){getNotes(); readyImagesForZoom();};
 			</xsl:text>
 		</script>
@@ -147,4 +147,28 @@
 				<tr><td>
 					<xsl:call-template name="viewOptions"/>
+					<table class="viewOptions"><tr>
+					<!-- Zoomer on/off button -->
+					<xsl:if test="/page/pageRequest/paramList/param[@name = 'zoom']/@value = 'on'">
+						<td>
+							<img src="sites/localsite/collect/peijones/images/zoom.png"/>
+							<input id="zoomOption" type="checkbox" class="optionCheckBox">
+								<xsl:choose>
+									<xsl:when test="/page/pageRequest/paramList/param[@name = 'zoom']/@value = 'on'">
+										<xsl:attribute name="onclick">
+											<xsl:text>removeZoom();</xsl:text>
+										</xsl:attribute>
+										<xsl:attribute name="checked">true</xsl:attribute>
+										<script type="text/javascript">function init(){readyImagesForZoom();} window.onload = init;</script>
+									</xsl:when>
+									<xsl:otherwise>
+										<xsl:attribute name="onclick">
+											<xsl:text>addZoom();</xsl:text>
+										</xsl:attribute>
+									</xsl:otherwise>
+								</xsl:choose>
+							</input>
+						</td>
+					</xsl:if>
+					</tr></table>
 				</td></tr>
 				<tr><td>
@@ -212,6 +236,6 @@
 
 		<div class="clear"><xsl:text> </xsl:text></div>
+
 	</xsl:template>
-	
 </xsl:stylesheet>
 