Index: /documentation/trunk/tutorials/xml-source/tutorial_en.xml
===================================================================
--- /documentation/trunk/tutorials/xml-source/tutorial_en.xml	(revision 24634)
+++ /documentation/trunk/tutorials/xml-source/tutorial_en.xml	(revision 24635)
@@ -673,5 +673,5 @@
 </Heading>
 <NumberedItem>
-<Text id="0366">Lets change the size of the thumbnail image and make it smaller. Thumbnail images are created by the <AutoText text="ImagePlugin"/> plug-in, so we need to access its configuration settings. To do this, switch to the <AutoText key="glidict::GUI.Design"/> panel and select <AutoText key="glidict::CDM.GUI.Plugins"/> from the list on the left. Double-click <AutoText text="ImagePlugin"/> to pop up a window that shows its settings. (Alternatively, select <AutoText text="ImagePlugin"/> with a single click and then click <AutoText key="glidict::CDM.PlugInManager.Configure" type="button"/> further down the screen). Currently most options are off, so standard defaults are used. Select <AutoText text="thumbnailsize"/>, set it to <AutoText text="50"/>, and click <AutoText key="glidict::General.OK" type="button"/>.</Text>
+<Text id="0366">Let's change the size of the thumbnail image and make it smaller. Thumbnail images are created by the <AutoText text="ImagePlugin"/> plug-in, so we need to access its configuration settings. To do this, switch to the <AutoText key="glidict::GUI.Design"/> panel and select <AutoText key="glidict::CDM.GUI.Plugins"/> from the list on the left. Double-click <AutoText text="ImagePlugin"/> to pop up a window that shows its settings. (Alternatively, select <AutoText text="ImagePlugin"/> with a single click and then click <AutoText key="glidict::CDM.PlugInManager.Configure" type="button"/> further down the screen). Currently most options are off, so standard defaults are used. Select <AutoText text="thumbnailsize"/>, set it to <AutoText text="50"/>, and click <AutoText key="glidict::General.OK" type="button"/>.</Text>
 </NumberedItem>
 <NumberedItem>
@@ -1802,5 +1802,5 @@
 <Text id="is-11a">Make fielded searching the default by changing the <AutoText text="SearchTypes"/> format statement to <AutoText text="form,plain"/> (instead of <AutoText text="plain,form"/>).</Text>
 </NumberedItem>
-<Text id="is-13"><AutoText text="ISISPlug"/> stores a nicely formatted version of the record as the document text, and this is what is displayed when we view a record. Lets tidy it up a little more.</Text>
+<Text id="is-13"><AutoText text="ISISPlug"/> stores a nicely formatted version of the record as the document text, and this is what is displayed when we view a record. Let's tidy it up a little more.</Text>
 <NumberedItem>
 <Text id="is-14">Remove the <AutoText key="coredm::_document:textDETACH_" type="italics"/> and <AutoText key="coredm::_document:textNOHIGHLIGHT_" type="italics"/> buttons by setting the <AutoText text="DocumentButtons"/> format statement to empty.</Text>
@@ -1949,5 +1949,5 @@
 <comment>(If a collection title image is used, you won't see the change on the collection title.)</comment>
 <NumberedItem>
-<Text id="mf-28">Lets switch the positions of the HOME, HELP and PREFERENCES buttons and the collection name or image.</Text>
+<Text id="mf-28">Let's switch the positions of the HOME, HELP and PREFERENCES buttons and the collection name or image.</Text>
 <BulletList>
 <Bullet>
@@ -2028,5 +2028,5 @@
 <Command>findstr /s /m /C:"gsdlhead.gif" "C:\Program Files\Greenstone\macros\*.dm"</Command>
 <Text id="mf-70"><AutoText text="*.dm"/> means all files ending in <AutoText text=".dm"/> (while <AutoText text="/s"/> tells it to search within subfolders and <AutoText text="/m"/> lists the files that matched). A list of all applicable macro files will be displayed, along with any matches. You will see that <Path>home.dm</Path> and <Path>exported_home.dm</Path> both contain <AutoText text="gsdlhead.gif"/>. <Path>home.dm</Path> is the one you want to edit&mdash;<Path>exported_home.dm</Path> is used for the home page when you export a collection to CD-ROM. On Linux systems, the equivalent command to run in a terminal would be:</Text>
-<Command>fgrep -rl "gsdlhead.gif" /full/path/to/your/greenstone/macros/.</Command>
+<Command>fgrep -rl "gsdlhead.gif" /full/path/to/your/greenstone/macros/</Command>
 <Text id="mf-71">Do the same thing for <i><AutoText text="chalk.gif" /></i>:</Text>
 <Command>findstr /s /m /C:"chalk.gif" "C:\Program Files\Greenstone\macros\*.dm"</Command>
@@ -2333,5 +2333,5 @@
 </NumberedItem>
 <NumberedItem>
-<Text id="0646">Using the file browser, copy the <Path>images</Path> and <Path>macros</Path> folders from the <Path>advbeat_large</Path> folder into the <Path>smallbea</Path> folder. (It's OK to overwrite the existing <Path>images</Path> folder: the image in it is included in the folder being copied.) The <Path>images</Path> folder includes some useful icons, and the <Path>macros</Path> folder defines some macro names that use these images.</Text>
+<Text id="0646">Using the file browser, copy the <Path>macros</Path> folder from the <Path>advbeat_large</Path> folder into the <Path>smallbea</Path> folder. (It's OK to overwrite the existing <Path>images</Path> folder: the image in it is included in the folder being copied.) The <Path>images</Path> folder includes some useful icons, and the <Path>macros</Path> folder defines some macro names that use these images.</Text>
 <Text id="0646a">To see the macro definitions, open the collection in the Librarian Interface (<Menu><AutoText key="glidict::Menu.File"/> &rarr; <AutoText key="glidict::Menu.File_Open"/></Menu>) and view the <AutoText key="glidict::CDM.GUI.Macros"/> section in the <AutoText key="glidict::GUI.Format"/> panel.</Text>
 </NumberedItem>
@@ -2552,5 +2552,5 @@
 </Heading>
 <Comment>
-<Text id="0690f">You will notice that when searching for individual pages, a thumbnail of the newspaper image is displayed in the search results. For text pages like this, these are not very useful. Lets tell <AutoText text="PagedImagePlugin"/> not to generate thumbnails.</Text>
+<Text id="0690f">You will notice that when searching for individual pages, a thumbnail of the newspaper image is displayed in the search results. For text pages like this, these are not very useful. Let's tell <AutoText text="PagedImagePlugin"/> not to generate thumbnails.</Text>
 </Comment>
 <NumberedItem>
@@ -2561,5 +2561,5 @@
 </NumberedItem>
 <Comment>
-<Text id="0690e-1">Search results at newspaper level display the original filename. Lets remove that also.</Text>
+<Text id="0690e-1">Search results at newspaper level display the original filename. Let's remove that also.</Text>
 </Comment>
 <NumberedItem>
@@ -2571,5 +2571,5 @@
 </NumberedItem>
 <Comment>
-<Text id="0690h">You might notice that newspaper level search results only display a large scan of the newspaper page, the newspaper Title, and not any volume information, while page level search results only show the Title of the page (the page number), and not the Title of the newspaper. We'll modify the format statement to show Volume and Number information, and for page results, the newspaper title as well as the page number.</Text>
+<Text id="0690h">You might notice that newspaper level search results only display the newspaper Title, and not any volume information, while page level search results only show a large scan of the newspaper page, the Title of the page (the page number), and not the Title of the newspaper. We'll modify the format statement to show Volume and Number information, and for page results, the newspaper title as well as the page number.</Text>
 </Comment>
 <NumberedItem>
@@ -2703,5 +2703,5 @@
 </NumberedItem>
 <NumberedItem>
-<Text id="sc25c">Go to the <AutoText key="glidict::CDM.GUI.Plugins"/> section of the <AutoText key="glidict::GUI.Design"/> panel, and add a new <AutoText text="PagedImagePlugin"/> plugin. Enable the <AutoText text="create_screenview"/> option, set the <AutoText text="documenttype"/> option to <AutoText text="hierarchy"/> and set the <AutoText text="process_exp"/> option to <AutoText text="xml.*\.item$"/>.</Text>
+<Text id="sc25c">Go to the <AutoText key="glidict::CDM.GUI.Plugins"/> section of the <AutoText key="glidict::GUI.Design"/> panel, and add a new <AutoText text="PagedImagePlugin"/> plugin. Enable the <AutoText text="create_screenview"/> option, set the <AutoText text="documenttype"/> option to <AutoText text="hierarchy"/> and set the <AutoText text="process_exp"/> option to <AutoText text="xml.*\.item$"/> and click <AutoText key="glidict::General.OK"/>.</Text>
 </NumberedItem>
 <NumberedItem>
@@ -2786,5 +2786,5 @@
 </Comment>
 <NumberedItem>
-<Text id="oai-plugin-option">Move the <AutoText text="OAIPlugin"/> above the <AutoText text="EmbeddedMetadataPlugin"/>. Next, you will need to specify which document the OAI metadata values should be attached to. In the <AutoText key="glidict::GUI.Design"/> panel, select the <AutoText key="glidict::CDM.GUI.Plugins"/> section, then select the <AutoText text="OAIPlugin"/> and click <AutoText key="glidict::CDM.PlugInManager.Configure" type="button"/>. Locate the <AutoText text="document_field"/> option in the popup window and select <AutoText text="dc.Resource Identifier"/> from the drop-down list. Click <AutoText key="glidict::General.OK" type="button"/>.</Text>
+<Text id="oai-plugin-option">You will need to specify which document the OAI metadata values should be attached to. In the <AutoText key="glidict::GUI.Design"/> panel, select the <AutoText key="glidict::CDM.GUI.Plugins"/> section, then select the <AutoText text="OAIPlugin"/> and click <AutoText key="glidict::CDM.PlugInManager.Configure" type="button"/>. Locate the <AutoText text="document_field"/> option in the popup window and select <AutoText text="ex.dc.Identifier"/> from the drop-down list. Click <AutoText key="glidict::General.OK" type="button"/>. Finally, move the <AutoText text="OAIPlugin"/> above the <AutoText text="EmbeddedMetadataPlugin"/>.</Text>
 </NumberedItem>
 <NumberedItem>
@@ -3074,5 +3074,6 @@
 <Text id="0790c">Type:</Text>
 <Command>setup</Command> 
-<Text id="0790d">to set up the ability to run Greenstone command-line programs.</Text>
+<Text id="0790d">to set up the ability to run Greenstone command-line programs. On a Linux or Mac machine, you would type:</Text>
+<Command>source setup.bash</Command> 
 </NumberedItem>
 <NumberedItem>
@@ -3207,5 +3208,5 @@
 </Heading>
 <NumberedItem>
-<Text id="indexers-26">MGPP supports stemming, casefolding and accentfolding. By default search in collections built with MGPP indexer is set to <AutoText key="coredm::_preferences:textnostem_"/> and <AutoText key="coredm::_preferences:textignorecase_"/>. So search <i>econom</i> will return 0 documents. Search for <i>fao</i> and <i>FAO</i> return the same result &mdash; 85 word counts and 11 matched documents.</Text>
+<Text id="indexers-26">MGPP supports stemming, casefolding and accentfolding. By default, searching in collections built with MGPP indexer is set to <AutoText key="coredm::_preferences:textnostem_"/> and <AutoText key="coredm::_preferences:textignorecase_"/>. So searching <i>econom</i> will return 0 documents. Searching for <i>fao</i> and <i>FAO</i> return the same result &mdash; 85 word counts and 11 matched documents.</Text>
 <Text id="indexers-26a">Go to the <AutoText key="coredm::_Global:linktextPREFERENCES_"/> page by clicking the <AutoText key="coredm::_Global:linktextPREFERENCES_"/> button at the top right corner. You can see that the <AutoText key="coredm::_preferences:textwordends_"/> option is set to <AutoText key="coredm::_preferences:textnostem_"/> and the <AutoText key="coredm::_preferences:textcasediffs_"/> option is set to <AutoText key="coredm::_preferences:textignorecase_"/>.</Text>
 </NumberedItem>
@@ -3284,5 +3285,5 @@
 </NumberedItem>
 <NumberedItem>
-<Text id="depositor-user3">Let's modify the groups for the demo user. This user was added for the authentication demonstration collection to allow restricted access to some of the documents. If this user doesn't exist for you, create a new user by clicking on the <AutoText key="auxdm::_status:textaddusers_"/> link under the <AutoText key="auxdm::_status:textusermanage_"/> section on the left. Give it the name "demo" and password "demo". Click <AutoText text="submit"/>.</Text>
+<Text id="depositor-user3">Let's modify the groups for the demo user. This user was added for the authentication demonstration collection to allow restricted access to some of the documents. If this user doesn't exist for you, create a new user by clicking on the <AutoText key="auxdm::_status:textaddusers_"/> link under the <AutoText key="auxdm::_status:textusermanage_"/> section on the left. Give it the name "demo" and password "demo". Click <AutoText text="submit"/>. Back in the Administration Pages, click the <AutoText key="auxdm::_status:textlistusers_"/> link and the new user "demo" should be listed there now.</Text>
 </NumberedItem>
 <NumberedItem>
@@ -3290,5 +3291,5 @@
 </NumberedItem>
 <NumberedItem>
-<Text id="depositor-user5">At the end of each user entry there are two links: <AutoText key="auxdm::_userslistusers:textedituser_"/> and <AutoText key="auxdm::_userslistusers:textdeleteuser_"/>. Click <AutoText key="auxdm::_userslistusers:textedituser_"/> on the <AutoText text="demo"/> user account, and you will be shown more detailed information about the demo user. Add <AutoText text="demoluce-collection-editor"/> at the end of the <AutoText key="auxdm::_userslistusers:textgroups_"/> line, using a comma to separate group entries, so that the <AutoText key="auxdm::_userslistusers:textgroups_"/> field now contains: 
+<Text id="depositor-user5">In the <AutoText key="auxdm::_status:textlistusers_"/> page, at the end of each user entry there are two links: <AutoText key="auxdm::_userslistusers:textedituser_"/> and <AutoText key="auxdm::_userslistusers:textdeleteuser_"/>. Click <AutoText key="auxdm::_userslistusers:textedituser_"/> on the <AutoText text="demo"/> user account, and you will be shown more detailed information about the demo user. Add <AutoText text="demoluce-collection-editor"/> at the end of the <AutoText key="auxdm::_userslistusers:textgroups_"/> line, using a comma to separate group entries, so that the <AutoText key="auxdm::_userslistusers:textgroups_"/> field now contains: 
 <Format>demo,demoluce-collection-editor.</Format> (Note, if your collection shortname is not demoluce, then replace demoluce with the appropriate name in ***-collection-editor.)</Text>
 </NumberedItem>